# coding: utf-8

"""
    Pure1 Public REST API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re

import six
import typing

from ....properties import Property
if typing.TYPE_CHECKING:
    from pypureclient.pure1.Pure1_1_2 import models

class SustainabilityInsightArray(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'as_of': 'int',
        'interval_start': 'int',
        'interval_end': 'int',
        'additional_data': 'object',
        'resource': 'FixedReferenceFqdn',
        'severity': 'str',
        'type': 'str'
    }

    attribute_map = {
        'as_of': '_as_of',
        'interval_start': '_interval_start',
        'interval_end': '_interval_end',
        'additional_data': 'additional_data',
        'resource': 'resource',
        'severity': 'severity',
        'type': 'type'
    }

    required_args = {
    }

    def __init__(
        self,
        as_of=None,  # type: int
        interval_start=None,  # type: int
        interval_end=None,  # type: int
        additional_data=None,  # type: object
        resource=None,  # type: models.FixedReferenceFqdn
        severity=None,  # type: str
        type=None,  # type: str
    ):
        """
        Keyword args:
            as_of (int): The freshness of the data (timestamp in millis since epoch).
            interval_start (int): The timestamp of the start of the time interval.
            interval_end (int): The timestamp of the end of the time interval.
            additional_data (object): The arbitrary data associated with the insight.
            resource (FixedReferenceFqdn)
            severity (str): The severity of the insight. Should be one of medium, high.
            type (str): The type of the insight.
        """
        if as_of is not None:
            self.as_of = as_of
        if interval_start is not None:
            self.interval_start = interval_start
        if interval_end is not None:
            self.interval_end = interval_end
        if additional_data is not None:
            self.additional_data = additional_data
        if resource is not None:
            self.resource = resource
        if severity is not None:
            self.severity = severity
        if type is not None:
            self.type = type

    def __setattr__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `SustainabilityInsightArray`".format(key))
        self.__dict__[key] = value

    def __getattribute__(self, item):
        value = object.__getattribute__(self, item)
        if isinstance(value, Property):
            raise AttributeError
        else:
            return value

    def __getitem__(self, key):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `SustainabilityInsightArray`".format(key))
        return object.__getattribute__(self, key)

    def __setitem__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `SustainabilityInsightArray`".format(key))
        object.__setattr__(self, key, value)

    def __delitem__(self, key):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `SustainabilityInsightArray`".format(key))
        object.__delattr__(self, key)

    def keys(self):
        return self.attribute_map.keys()

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            if hasattr(self, attr):
                value = getattr(self, attr)
                if isinstance(value, list):
                    result[attr] = list(map(
                        lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                        value
                    ))
                elif hasattr(value, "to_dict"):
                    result[attr] = value.to_dict()
                elif isinstance(value, dict):
                    result[attr] = dict(map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict") else item,
                        value.items()
                    ))
                else:
                    result[attr] = value
        if issubclass(SustainabilityInsightArray, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SustainabilityInsightArray):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
